#include "enforce.h"
#include <iostream>

int* simulateSuccess()
{
  static int i = 0;
  return &i;
}

int* simulateError()
{
  return 0;
}

void foo(int* pInt)
{
}

struct Widget
{
  void print()
  {
    std::cerr << 1 << ". This is the Widget!" << std::endl;
  }
};

Widget* makeWidget()
{
  static Widget o;
  return &o;
}

int main()
{
    try
    {
        ENFORCE(simulateSuccess());
        int* pInt = ENFORCE(simulateSuccess())("You should not ")("see")(" this message.");
        Widget* pObj = ENFORCE(makeWidget())("Hopefully you don't ")("see this either!");
        pObj->print();
        foo(ENFORCE(simulateError())(2)(". An exception will be thrown ")(" below."));
    }
    catch (const std::exception& e)
    {
        std::cerr << e.what() << std::endl;
    }
    return 0;
}


