/////////////////////////////////////////////////////////////////////
// Code accompanying "The Embedded Angle" column in CUJ
// Copyright 2002-2003 by Miro Samek, http://www.quantum-leaps.com 
// All Rights Reserved.
/////////////////////////////////////////////////////////////////////
#include "fsm.h"

static Event const entryEvt = { ENTRY_SIG }; 
static Event const exitEvt = { EXIT_SIG }; 

void Fsm::initialTran(State target) {
   myState = target;                          // change current state
   dispatch(&entryEvt);                           // enter the target
}

void Fsm::tran(State target) {
   dispatch(&exitEvt);                             // exit the source
   myState = target;                          // change current state
   dispatch(&entryEvt);                           // enter the target
}
